#ifndef SAFEARRAY2_H_
#define SAFEARRAY2_H_

class SafeArray
{
public:
    SafeArray()        : length(0),   elements(nullptr)         {}
    SafeArray(int len) : length(len), elements(new int[length]) {}

    virtual ~SafeArray() { if (elements != nullptr) delete[] elements; }

    int get_length() const { return length; }

    int at(int i) const;
    void set(int i, int value);

    void operator =(const SafeArray& rhs);

private:
    int length;
    int *elements;
};

#endif /* SAFEARRAY2_H_ */
